<!---This file updates the cart contents.--->

<!---Create temporary variables to use instead of accessing the session variables over and over--->
<cflock scope="Session" type="EXCLUSIVE" timeout="10">
<cfoutput>
<cfset cart.CrtItemID = '#session.CrtItemID#'>
<cfset cart.CrtProductID = '#session.CrtProductID#'>
<cfset cart.CrtProductName = '#session.CrtProductName#'>
<cfset cart.CrtQuantity = '#session.CrtQuantity#'>
<cfset cart.CrtPrice = '#session.CrtPrice#'>
<cfset Cart.CrtThumbNails = '#session.CrtThumbNails#'>
</cfoutput>
</cflock>

<!---First update the quantities--->
<cfloop index="MyCount" from="1" To="#ListLen(Form.ChangeQuantity)#">
<cfset QToChange = #ListGetAt(form.ChangeQuantity, MyCount, ",")#>
<!---Get the previous Quantity of this item--->
<cfset OldQuantity = #ListGetAt(form.OldQuantity, MyCount, ",")#>

<cfif isnumeric(qToChange)>
	<cfif NOT QToChange IS 0>
		<cfif NOT QTochange CONTAINS "-">

			<CFSET NewQuantity = #QToChange#>

			<cfoutput>
				<cfset TheItemID = #ListGetAt(cart.CrtItemID, MyCount, "^")#>
			</cfoutput>

			<!---Get the actual price of each of this item from the database--->
			<cfinclude template = "../queries/qryProducts.cfm">

			<cfoutput query = "QryProducts">
				<cfset PriceEach = #Price#>
			</cfoutput>

			<!---Set new quantity--->
			<cfoutput>
				<CFSET SetQuantity = ListSetAt(cart.CrtQuantity, MyCount, #NewQuantity#, "^")>
				<CFSET cart.CrtQuantity = #SetQuantity#>
			</cfoutput>

			<!---Recalculate the price--->
			<cfset TotalOfItems = #PriceEach# * #NewQuantity#>
			
			<CFSET NewPrice = ListSetAt(#cart.CrtPrice#, #MyCount#, #TotalOfItems#, "^")>
			<CFSET cart.CrtPrice = #NewPrice#>		
		</cfif>
	</cfif>
</cfif>

</cfloop>

<!---Next Delete items from the cart that were checked--->
<cfset ItemsDeleted = 0>
<cfif ISDEFINED('form.DeleteList')>
	<cfloop index="MyCount" from="1" To="#ListLen(Form.deleteList)#">

	<!---Find Out which item(s) should be deleted--->
	<cfset ItemToDelete = ListGetAt(#form.deleteList#, MyCount)>
	<cfset ItemToDelete = ItemToDelete - ItemsDeleted>

	<!---Now Delete the item at the CartIndex Number--->
		<cfoutput>
			<CFSET NewItemID = ListDeleteAt(#cart.CrtItemID#, #ItemToDelete#, "^")>
			<CFSET cart.CrtItemID = #NewItemID#>
			<CFSET NewProductName = ListDeleteAt(#cart.CrtProductName#, #ItemToDelete#, "^")>
			<CFSET cart.CrtProductName = #NewProductName#>
			<CFSET NewProductID = ListDeleteAt(#cart.CrtProductID#, #ItemToDelete#, "^")>
			<CFSET cart.CrtProductID = #NewProductID#>
			<CFSET NewQuantity = ListDeleteAt(#cart.CrtQuantity#, #ItemToDelete#, "^")>
			<CFSET cart.CrtQuantity = #NewQuantity#>
			<CFSET NewPrice = ListdeleteAt(#cart.CrtPrice#, #ItemToDelete#, "^")>
			<CFSET cart.CrtPrice = #NewPrice#>
			<CFSET NewThumbNails = ListDeleteAt(#Cart.CrtThumbnails#, #ItemToDelete#, "^")>
			<CFSET Cart.CrtThumbNails = #NewThumbNails#>
			<cfset ItemWasDeleted = 'Yes'>
		<cfset ItemsDeleted = ItemsDeleted + 1>
		</cfoutput>
  </cfloop>
</cfif>

<!---Write the temporary variables back to the session variables--->
<cflock scope="SESSION" type="EXCLUSIVE" timeout="10">
	<cfoutput>
		<cfset session.CrtItemID = '#Cart.CrtItemID#'>
		<cfset session.CrtProductID = '#cart.CrtProductID#'>
		<cfset session.CrtProductName = '#cart.CrtProductName#'>
		<cfset session.CrtQuantity = '#cart.CrtQuantity#'>
		<cfset session.CrtPrice = '#cart.CrtPrice#'>
		<cfset session.CrtThumbnails = '#Cart.CrtThumbNails#'>
	</cfoutput>
</cflock>

<cflocation url = "index.cfm?action=view">